require ( "config" )

local placements = {}
placements[1] = 
{
	{ name = "steel-chest", position = { x = -0.5, y = 0.5 }, direction = 0, 
		contents = { 
		{ name = "science-pack-1", count = 1000 }, 
		{ name = "science-pack-2", count = 1000 },
		{ name = "science-pack-3", count = 1000 }, 
		{ name = "military-science-pack", count = 1000 }, 
		{ name = "production-science-pack", count = 1000 }, 
		{ name = "high-tech-science-pack", count = 1000 }, 
		{ name = "space-science-pack", count = 1000 }, 
		} 
	},
	{ name = "steel-chest", position = { x = 1.5, y = 0.5 }, direction = 0, 
		contents = { 
		{ name = "science-pack-1", count = 1000 }, 
		{ name = "science-pack-2", count = 1000 },
		{ name = "science-pack-3", count = 1000 }, 
		{ name = "military-science-pack", count = 1000 }, 
		{ name = "production-science-pack", count = 1000 }, 
		{ name = "high-tech-science-pack", count = 1000 }, 
		{ name = "space-science-pack", count = 1000 }, 
		} 
	},
	{ name = "steel-chest", position = { x = 1.5, y = -1.5 }, direction = 0, 
		contents = { 
		{ name = "science-pack-1", count = 1000 }, 
		{ name = "science-pack-2", count = 1000 },
		{ name = "science-pack-3", count = 1000 }, 
		{ name = "military-science-pack", count = 1000 }, 
		{ name = "production-science-pack", count = 1000 }, 
		{ name = "high-tech-science-pack", count = 1000 }, 
		{ name = "space-science-pack", count = 1000 }, 
		} 
	},
	{ name = "steel-chest", position = { x = -0.5, y = -1.5 }, direction = 0, 
		contents = { 
		{ name = "science-pack-1", count = 1000 }, 
		{ name = "science-pack-2", count = 1000 },
		{ name = "science-pack-3", count = 1000 }, 
		{ name = "military-science-pack", count = 1000 }, 
		{ name = "production-science-pack", count = 1000 }, 
		{ name = "high-tech-science-pack", count = 1000 }, 
		{ name = "space-science-pack", count = 1000 }, 
		} 
	},
	{ name = "fast-inserter", position = { x = -0.5, y = 1.5 }, direction = 0, },
	{ name = "fast-inserter", position = { x = 1.5, y = 1.5 }, direction = 0, },
	{ name = "fast-inserter", position = { x = 2.5, y = 0.5 }, direction = 6, },
	{ name = "fast-inserter", position = { x = 2.5, y = -1.5 }, direction = 6, },
	{ name = "fast-inserter", position = { x = 1.5, y = -2.5 }, direction = 4, },
	{ name = "fast-inserter", position = { x = -0.5, y = -2.5 }, direction = 4, },
	{ name = "fast-inserter", position = { x = -1.5, y = -1.5 }, direction = 2, },
	{ name = "fast-inserter", position = { x = -1.5, y = 0.5 }, direction = 2, },
	{ name = "lab", position = { x = 4.5, y = -0.5 }, direction = 0, },
	{ name = "lab", position = { x = 0.5, y = -4.5 }, direction = 0, },
	{ name = "lab", position = { x = -3.5, y = -0.5 }, direction = 0, },
	{ name = "lab", position = { x = 0.5, y = 3.5 }, direction = 0, },
	{ name = "medium-electric-pole", position = { x = 0.5, y = -0.5 }, direction = 0, },
	{ name = "medium-electric-pole", position = { x = -5.5, y = 5.5 }, direction = 0, },
	{ name = "medium-electric-pole", position = { x = 6.5, y = 5.5 }, direction = 0, },
	{ name = "medium-electric-pole", position = { x = 6.5, y = -6.5 }, direction = 0, },
	{ name = "medium-electric-pole", position = { x = -5.5, y = -6.5 }, direction = 0, },
	{ name = "solar-panel", position = { x = -7.5, y = 3.5 }, direction = 0, },
	{ name = "solar-panel", position = { x = -7.5, y = 7.5 }, direction = 0, },
	{ name = "solar-panel", position = { x = -3.5, y = 7.5 }, direction = 0, },
	{ name = "solar-panel", position = { x = -3.5, y = 3.5 }, direction = 0, },
	{ name = "solar-panel", position = { x = 4.5, y = 3.5 }, direction = 0, },
	{ name = "solar-panel", position = { x = 4.5, y = 7.5 }, direction = 0, },
	{ name = "solar-panel", position = { x = 8.5, y = 7.5 }, direction = 0, },
	{ name = "solar-panel", position = { x = 8.5, y = 3.5 }, direction = 0, },	
	{ name = "solar-panel", position = { x = 4.5, y = -4.5 }, direction = 0, },
	{ name = "solar-panel", position = { x = 8.5, y = -4.5 }, direction = 0, },
	{ name = "solar-panel", position = { x = 8.5, y = -8.5 }, direction = 0, },
	{ name = "solar-panel", position = { x = 4.5, y = -8.5 }, direction = 0, },
	{ name = "accumulator", position = { x = -3, y = -4 }, direction = 0, },
	{ name = "accumulator", position = { x = -5, y = -4 }, direction = 0, },
	{ name = "accumulator", position = { x = -7, y = -4 }, direction = 0, },
	{ name = "accumulator", position = { x = -7, y = -6 }, direction = 0, },
	{ name = "accumulator", position = { x = -7, y = -8 }, direction = 0, },
	{ name = "accumulator", position = { x = -5, y = -8 }, direction = 0, },
	{ name = "accumulator", position = { x = -3, y = -8 }, direction = 0, },
	{ name = "accumulator", position = { x = -3, y = -6 }, direction = 0, },
}

function Create_entity( surface, area, center_area, team, robot )

	local num = math.random( 1, #placements )

	for k, v in pairs ( placements[num] ) do
	
		if not surface.can_place_entity{  
		name = string.gsub( v.name, "ID", robot.id ), 
		force = team, 
		direction = v.direction, 
		position = { center_area.x + v.position.x, center_area.y + v.position.y }
		} then return end
	
	end

	for k, v in pairs ( placements[num] ) do
	
		local entity = surface.create_entity{ 
		name = string.gsub( v.name, "ID", robot.id ), 
		force = team, 
		direction = v.direction, 
		position = { center_area.x + v.position.x, center_area.y + v.position.y }
		}
		if v.contents then
		
			for _, i  in pairs ( v.contents ) do
				
				entity.insert( i )
			
			end
		
		end
	
	end


end

function DistantFromOrigin( x, y )

	if x < 0 then x = x * -1 end
	if y < 0 then y = y * -1 end

	if x > 256 or y > 256 then return true end

end

function Chunk_generated( event )

	local surface = event.surface
	local area = event.area
	local center_area = { x = ( area["left_top"].x + area["right_bottom"].x ) / 2, y = ( area["left_top"].y + area["right_bottom"].y ) / 2 }
	
	if DistantFromOrigin( center_area.x, center_area.y ) then
	
		for k, v in pairs ( Robots ) do
		
			if game.forces[v.team] == nil then return end
		
			if math.random( 1, v.outpost_chance_penalty ) == 1 then
			
				Create_entity( surface, area, center_area, v.team, v )
			
				break
			
			end
		
		end
		
	end
	
end

function ResearchFinish( event )

	local research = event.research
	local force = research.force
	
	if not ( force.name == "player" ) then
	
	
		for k, v in pairs( game.forces[force.name].technologies ) do
		
			if not v.researched and v.research_unit_count_formula == nil then
			
				game.forces[force.name].current_research = v.name
				
				break
				
			end
		
		end
	
	end
	
end

function ForceCreated( event )

	local force = event.force
	
	if not ( force.name == "player" ) then
	
		game.forces[force.name].current_research = "automation"	
	
	end
	
end

script.on_event( defines.events.on_force_created, ForceCreated )
script.on_event( defines.events.on_research_finished, ResearchFinish )
script.on_event( defines.events.on_chunk_generated, Chunk_generated )
script.on_init( function()

	for k, v in pairs( Robots ) do

		if game.forces[v.team] ~= nil then
		
			game.forces[v.team].current_research = "automation"	
		
		end
	
	end

end )
