
function small_robot_factory_idle_animation(tint)
return
  {
    layers =
    {
        {
          filename = "__ManVersusMachine__/graphics/entity/small-robot-factory/small-robot-factory.png",
          priority = "high",
          width = 224,
          height = 224,
          frame_count = 8,
          --line_length = 8,
          shift = {1.4, -0.75},
        },
		{
          filename = "__ManVersusMachine__/graphics/entity/small-robot-factory/small-robot-factory-mask.png",
          priority = "high",
          width = 224,
          height = 224,
          frame_count = 8,
          --line_length = 8,
          shift = {1.4, -0.75},
		  tint = { r = tint.r, b = tint.b, g = tint.g, a = 0.25 },
        },
    },
  }
end

function medium_robot_factory_idle_animation(tint)
return
  {
    layers =
    {
        {
          filename = "__ManVersusMachine__/graphics/entity/medium-robot-factory/medium-robot-factory.png",
          priority = "high",
          width = 320,
          height = 320,
          frame_count = 8,
          line_length = 4,
          shift = {1.4, -0.5},
        },
		{
          filename = "__ManVersusMachine__/graphics/entity/medium-robot-factory/medium-robot-factory-mask.png",
          priority = "high",
          width = 320,
          height = 320,
          frame_count = 8,
          line_length = 4,
          shift = {1.4, -0.5},
		  tint = { r = tint.r, b = tint.b, g = tint.g, a = 0.25 },
        },
    },
  }
end

function large_robot_factory_idle_animation(tint)
return
  {
    layers =
    {
        {
          filename = "__ManVersusMachine__/graphics/entity/large-robot-factory/large-robot-factory.png",
          priority = "high",
          width = 416,
          height = 288,
          frame_count = 8,
          line_length = 4,
          shift = {1.4, -0.3},
        },
		{
          filename = "__ManVersusMachine__/graphics/entity/large-robot-factory/large-robot-factory-mask.png",
          priority = "high",
          width = 416,
          height = 288,
          frame_count = 8,
          line_length = 4,
          shift = {1.4, -0.3},
		  tint = { r = tint.r, b = tint.b, g = tint.g, a = 0.25 },
        },
    },
  }
end

function giant_robot_factory_idle_animation(tint)
return
  {
    layers =
    {
        {
          filename = "__ManVersusMachine__/graphics/entity/giant-robot-factory/giant-robot-factory.png",
          priority = "high",
          width = 512,
          height = 352,
          frame_count = 8,
          line_length = 4,
          shift = {1.8, -0.25},
        },
		{
          filename = "__ManVersusMachine__/graphics/entity/giant-robot-factory/giant-robot-factory-mask.png",
          priority = "high",
          width = 512,
          height = 352,
          frame_count = 8,
          line_length = 4,
          shift = {1.8, -0.25},
		  tint = { r = tint.r, b = tint.b, g = tint.g, a = 0.25 },
        },
    },
  }
end

--[[function small_robot_factory_die_animation(variation, tint)
return
  {
    layers =
    {
      {
        width = 255,
        height = 184,
        frame_count = 20,
        direction_count = 1,
        shift = {-0.015625 - 0.65, -0.28125},
        stripes =
        {
         {
          filename = "__base__/graphics/entity/spawner/spawner-die-01.png",
          width_in_frames = 7,
          height_in_frames = 4,
          y = variation * 184
         },
         {
          filename = "__base__/graphics/entity/spawner/spawner-die-02.png",
          width_in_frames = 7,
          height_in_frames = 4,
          y = variation * 184
         },
         {
          filename = "__base__/graphics/entity/spawner/spawner-die-03.png",
          width_in_frames = 6,
          height_in_frames = 4,
          y = variation * 184
         }
        }
      },
      {
        flags = { "mask" },
        width = 166,
        height = 148,
        frame_count = 20,
        direction_count = 1,
        shift = {-0.34375 - 0.65, -0.375},
        tint = tint,
        stripes =
        {
         {
          filename = "__base__/graphics/entity/spawner/spawner-die-mask-01.png",
          width_in_frames = 10,
          height_in_frames = 4,
          y = variation * 148
         },
         {
          filename = "__base__/graphics/entity/spawner/spawner-die-mask-02.png",
          width_in_frames = 10,
          height_in_frames = 4,
          y = variation * 148
         }
        }
      }
    }
  }
end--]]

