
local animation_shift = { x = 0.65 , y = -1 }

function bot_run_animation( scale, tint, name )
  return
  {
    layers=
    {
      {
        width = 240,
        height = 240,
        frame_count = 2,
        direction_count = 16,
        shift = { animation_shift.x * scale, animation_shift.y * scale },
        scale = scale,
        stripes =
        {
         {
          filename = "__ManVersusMachine__/graphics/entity/"..name.."-bot/"..name.."-bot-1.png",
          width_in_frames = 2,
          height_in_frames = 8,
         },
         {
          filename = "__ManVersusMachine__/graphics/entity/"..name.."-bot/"..name.."-bot-2.png",
          width_in_frames = 2,
          height_in_frames = 8,
         }
        }
      },      
	  {
        width = 240,
        height = 240,
        frame_count = 2,
        direction_count = 16,
        shift = { animation_shift.x * scale, animation_shift.y * scale },
        scale = scale,
		tint = { r = tint.r, g = tint.g, b = tint.b, a = 0.4 },
        stripes =
        {
         {
          filename = "__ManVersusMachine__/graphics/entity/"..name.."-bot/"..name.."-bot-1-mask.png",
          width_in_frames = 2,
          height_in_frames = 8,
         },
         {
          filename = "__ManVersusMachine__/graphics/entity/"..name.."-bot/"..name.."-bot-2-mask.png",
          width_in_frames = 2,
          height_in_frames = 8,
         }
        }
      },
    }
  }
end

function bot_attack_animation( scale, tint, name )
  return
  {
    layers=
    {
      {
        width = 240,
        height = 240,
        frame_count = 2,
        direction_count = 16,
        shift = { animation_shift.x * scale, animation_shift.y * scale },
        scale = scale,
		animation_speed = 0.01,
        stripes =
        {
         {
          filename = "__ManVersusMachine__/graphics/entity/"..name.."-bot/"..name.."-bot-1.png",
          width_in_frames = 2,
          height_in_frames = 8,
         },
         {
          filename = "__ManVersusMachine__/graphics/entity/"..name.."-bot/"..name.."-bot-2.png",
          width_in_frames = 2,
          height_in_frames = 8,
         }
        }
      },
	  {
        width = 240,
        height = 240,
        frame_count = 2,
        direction_count = 16,
        shift = { animation_shift.x * scale, animation_shift.y * scale },
        scale = scale,
		tint = { r = tint.r, g = tint.g, b = tint.b, a = 0.4 },
        stripes =
        {
         {
          filename = "__ManVersusMachine__/graphics/entity/"..name.."-bot/"..name.."-bot-1-mask.png",
          width_in_frames = 2,
          height_in_frames = 8,
         },
         {
          filename = "__ManVersusMachine__/graphics/entity/"..name.."-bot/"..name.."-bot-2-mask.png",
          width_in_frames = 2,
          height_in_frames = 8,
         }
        }
      },
    }
  }
end
